import { useReducer } from "react";
import { data } from "./data";

import { CLEAR_LIST, RESET_LIST } from "./actions";
import reducer from "./reducer";

// default state
const defaultState = {
  books: data,
};

function App() {
  //// const [books, setBooks] = useState(data);
  // use useReducer hook instead
  // useReducer hook accepts 2 parameters - reducer function and default state
  // it returns the state and a function called dispath
  // where we can use to dispatch the action
  const [state, dispatch] = useReducer(reducer, defaultState);

  const clearList = () => {
    dispatch({ type: CLEAR_LIST });
  };

  const resetList = () => {
    dispatch({ type: RESET_LIST });
  };

  console.log(state);

  return (
    <>
      <h2>Advanced Web Development</h2>
      <h3>Reducer</h3>

      <div>
        <h4>Books by JK Rowling</h4>
        <button onClick={clearList}>Clear list</button>
        {state.books.items ? (
          state.books.items.map((book) => {
            const { id, volumeInfo } = book;
            return (
              <article key={id}>
                <h3>{volumeInfo.title}</h3>
                <h4>{volumeInfo.publisher}</h4>
                <p>{volumeInfo.description}</p>
              </article>
            );
          })
        ) : (
          <>
            <h3>No book is found</h3>
            <button onClick={resetList}>RESET</button>
          </>
        )}
      </div>
    </>
  );
}

export default App;
